#!/bin/bash

#####################################################
# Upgrades Postgres from 9.6.24 to 14.3
#####################################################
echo "Updates postgresql 9.6 to 14.3"
VERSION=$(rpm -qa --queryformat "%{VERSION}\n" postgresql*-server)
if ! [[ "$VERSION" =~ 9.6. ]]; then 
    echo "The postgres version is $VERSION, skip upgrade";
    exit 0
fi

# Shutdown Virgo
systemctl stop virgo

sudo mkdir -p /etc/systemd/system/postgresql-14.service.d/
echo -e "[Service]\nEnvironment=PGDATA=/data/postgres14.3" > /etc/systemd/system/postgresql-14.service.d/overrides.conf
systemctl daemon-reload

mkdir -p /data/postgres14.3
chown postgres:postgres /data/postgres14.3/
chmod 700 /data/postgres14.3/

# Initialize DB
/usr/pgsql-14/bin/postgresql-14-setup initdb

mv /usr/pgsql-9.6/bin/pg_ctl{,-orig}

echo '#!/bin/bash' > /usr/pgsql-9.6/bin/pg_ctl

echo '"$0"-orig "${@/unix_socket_directory/unix_socket_directories}"' >> /usr/pgsql-9.6/bin/pg_ctl

chmod +x /usr/pgsql-9.6/bin/pg_ctl

systemctl stop postgresql-9.6

# Dump data from 9.6 to 14.3 data directory (/data/postgres14.3)
cd /tmp
su -c "/usr/pgsql-14/bin/pg_upgrade -v -b /usr/pgsql-9.6/bin/ -B /usr/pgsql-14/bin/ -d /data/postgres_96 -D /data/postgres14.3" postgres

if [ $? != 0 ]; then
    "The postgresql upgrade failed"
    exit 1
fi

# Rollback pg_ctl
mv -f /usr/pgsql-9.6/bin/pg_ctl{-orig,}
# Copy over config files from the older version data directory.
su -c" cp /data/postgres_96/*.conf /data/postgres14.3" postgres

systemctl start postgresql-14
systemctl enable postgresql-14
systemctl disable postgresql-9.6
yum remove postgresql96* -y

echo 'export PATH=$PATH:/usr/pgsql-14/bin' >> /etc/bashrc
sudo sed -i 's#PGDATA=.*#PGDATA=/data/postgres14.3#g' /var/lib/pgsql/.bash_profile